%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                            %
% Übung flatten/2                                                            %
% Schreibe ein Prädikat my_flatten/2, das als Argument zwei Listen nimmt     %
% und gelingt,                                                               %
% wenn die zweite Liste die "Verflachung" der ersten Liste ist.              %
%                                                                            %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Erläuterung
% Die Verflachung einer Liste bedeutet hier, dass innerhalb einer Liste keine weiteren Listen vorhanden sind,
% sondern alle Elemente aus diesen Listen herausgeholt werden.

%
%%% 1. Lösungsmöglichtkeit mit Akkumulator
% myflatten/2
% myflatten(Liste, FlacheListe)
% myflatten ist wahr, wenn das erste Argument eine Liste ist und das zweite Argument die verflachte Version dieser Liste ist. 
% myflatten/2 nutzt das Hilfsprädikat myflatten/3 mit einem Akkumulator, der als Todo-Liste die noch zu verflachenden Elemente enthält
% myflatten(Liste, Akkumulator, FlacheListe)

myflatten(VL,FL):-              
    myflatten(VL,[],FL).

myflatten([],[],[]).                % myflatten ist wahr, wenn die zu verflachende Liste und der Akkumulator leer sind

myflatten([],[H|Acc],FL):-          % wenn die Liste leer ist,
    myflatten(H,Acc,FL).            % wird das erste Element von dem Akkumulator / der To-Do Liste genommen

myflatten([H|T],Acc,FL):-           % wenn in der Liste noch ein Element steht
    is_list(H),                     % und dieses Element ist eine Liste
    myflatten(H,[T|Acc],FL).        % dann versuche diese zu flatten und der Rest der ursprünglichen Liste wird vorerst vorne auf den Akkumulator gelegt
    
myflatten([H|T1],Acc,[H|T2]):-      % wenn in der Liste noch ein Element steht, schreiben wir es auf die flache Liste, wenn
    not(is_list(H)),                % dieses Element keine Liste ist
    myflatten(T1,Acc,T2).           % und dann rufen wir mit dem Rest der Liste flatten erneut auf


%
%%% 2. Lösungsmöglichkeit mit append/3
% flatten/ 2 mit append/3
% flatten(Liste, flacheListe)
% flatten ist wahr, wenn das erste Argument eine Liste ist und das zweite Argument die verflachte Version dieser Liste ist. 

flatten([],[]).             % die zuverflachende Liste ist flach, wenn sie leer ist

flatten([H|T],FL):-         % man trennt die Liste in Head und Tail
     flatten(H,HF),         % dann versucht man H flach zu machen und als Ergebnis bekommt man sozusagen eine flache Headliste HF
     flatten(T,TF),         % dann versucht man auch den Tail zu flatten und bekommt als Ergebnis TF
     my_append(HF,TF,FL).   % zuletzt konkatentiert man die beiden verflachten Ergebnisse  

flatten([H|T],[H|FL]):-     % man schreibt das erste Element der zu verflachenden Liste auf die Ergebnisliste FL, wenn
     not(is_list(H)),       % dieses Element keine Liste ist
     flatten(T,FL).         % und wir die Restliste zu FL auch verflachen können
