%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                     %
% Übung: Grammatik mit append/3                                       %
% 1) Wieviele Sätze können mit dieser Grammatik generiert werden?     %
% 2) Betrachte die folgende Anfrage im Tracemodus:                    %
%          ?- s([keine, katze, klaut, eine, maus]).                   %
% 3) Fällt dir eine Möglichkeit ein, die Prädikate für die            %
% Grammatikregeln effizienter zu definieren?                          %
% (Tipp: Es reicht, die Teilziele umzustellen.)                       %
%                                                                     %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Lexikon:
det([eine]).
det([die]).
det([keine]).
n([maus]).
n([katze]).
v([jagt]).
v([klaut]).

% Grammatikregeln:
s(L3) :-  np(L1),
          vp(L2),
          append(L1,L2,L3).

np(L3) :- det(L1),
          n(L2),
          append(L1,L2,L3). 

vp(L3) :- v(L1),
          np(L2),
          append(L1,L2,L3).

%
%% Erläuterungen
%
% 1) Mit dieser Grammatik lassen sich wieder 72 Sätze generieren, die alle die Länge 5 haben.
%
% 2) Zunächst muss man den Trace-Modus entsprechend aktivieren. Bei SWISH geht das folgendermaßen: trace, (s([keine, katze, klaut, eine, maus])).
% Beim schrittweisen durchgehen erkennt man, dass um s (Zeile 18) zu beweisen, np (Zeile 18) bewiesen werden muss. 
% Um np(Zeile 22) zu beweisen muss det(Zeile 22) bewiesen werden. Prolog kann det beweisen, indem es mit [eine](Zeile 9) belegt wird. 
% Dann geht er wieder in die Regeln der np und versucht als nächstes n(Zeile 23) zu beweisen und findet [maus]. 
% Prolog hat nun schon zwei Wörter gefunden, die beide nicht zur Anfrage passen. In den weiteren Traceschritten wird ein kompletter Satz aus der Wissensbasis gebastelt. 
% Erst im letzten Schritt bei s wird dann verglichen, ob die zusammengestellte np und die vp zusammen konkateniert L3 ergeben(Zeile 20), also der übergebene Satz aus der Anfrage.
% Da dies failed, wird ein neuer Versuch gestartet, indem Prolog automatisch zur letzten Wahlmöglichkeit geht und sich für das nächste Element entscheidet. 
% Auf diese Weise werden immer wieder neue Sätze generiert, bei denen erneut geprüft wird, ob dieser nun der Anfrage entspricht.
% 
% 3) Wie in Unteraufgabe 2 beschrieben ist das Problem bei dieser Grammatik, dass komplette Sätze generiert werden und diese zuletzt erst mit der Anfrage abgeglichen werden. 
% Das geschieht, weil unsere Regeln so angeordnet sind, dass der Anfragesatz L3 nicht von vorne hinein berücksichtigt wird. Es wird erst eine beliebige NP gebildet. 
% Um direkt den Satz miteinzubeziehen kann das Teilziel append nach vorne gezogen werden. Dadurch weiß Prolog, dass die Konkatenation aus L1 und L2 den Eingabesatz L3 ergeben soll. 
% Danach wird erst versucht für L1 eine NP zu bilden. Hier weiß Prolog aber schon, dass L1 eine Teilliste von L3 (also dem Anfragesatz) sein muss und 
% geht daher systematisch alle Aufteilungsmöglichkeiten von L3 in L1 und L2 durch. Auch die Regeln der NP sollten umgestellt werden, sodass nicht ein beliebiges det gewählt wird.
% Hier kann nach dem selben Muster das append als Teilziel an die erste Stelle gestellt werden. Dadurch wird der aus s bekannte Teilsatz hier direkt aufgegriffen. 
% Gleiches gilt für die Teilregeln des vp-Prädikates. Daraus entstehen folgende Grammatikregeln:

% Grammatikregeln:
s(L3) :-  append(L1,L2,L3),                       % Ein Satz L3 besteht aus L1, L2 und L3
          np(L1),                                 % die NP stellt L1 dar und
          vp(L2).                                 % eine VP stellt L2 dar

np(L3) :- append(L1,L2,L3),                       % Eine NP L3 besteht aus L1, L2 und L3
          det(L1),                                % der Determinierer stellt L1 dar und
          n(L2).                                  % das Nomen stellt L2 dar

vp(L3) :- append(L1,L2,L3),                       % Eine VP L3 besteht aus L1, L2 und L3
          v(L1),                                  % Das Verb stellt L1 dar und
          np(L2).                                 % eine NP stellt L2 dar
