%&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
&                                                                                       %
% Übung: Palindrom/1                                                                    %
% Schreibe ein Prädikat palindrom/1, das Palindrome erkennt.                            %
% Ein Wort ist ein Palindrom, wenn es von vorne und von hinten gelesen gleich ist.      %
%                                                                                       %
% Erläuterung:                                                                          %        
% Das Prädikat palindrom/1 nimmt eine Liste als Argument und gibt "true" zurück,        %
% wenn die Elemente dieser Liste in umgedrehter Reihenfolge dieselbe Liste ergeben.     %
% Auch die leere Liste wird als Palindrom gewertet.                                     %
%                                                                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Für die gegebene Aufgabenstellung haben wir zwei verschiedene Lösungen:

%%% Lösung Nr 1:
% Die erste Lösungsstrategie beruht auf der Nutzung von Akkumulatoren.
% Wir benötigen dafür also noch ein Prädikat palindrom/2 mit einem zusätzlichen Akkumulatorargument.
% Dieses Prädikat spaltet rekursiv immer den Head der Liste ab und fügt ihn der zu Beginn leeren Akkumulatorliste hinzu.
% Dies passiert so lange, bis eine der beiden Ankerklauseln erfüllt sind:
% Ankerklausel 1: Die Liste wurde genau zur Hälfte abgearbeitet, sodass Liste und Akkumulatorliste identisch sind. 
% Dies geschieht nur, wenn die Anzahl der Elemente der Eingabeliste gerade ist.
% Ankerklausel 2: Die Anzahl der Listenelemente ist ungerade und die Liste wurde bis zu dem Punkt abgearbeitet, 
% an dem, abgesehen vom aktuellen Head-Element, Liste und Akkumulatorliste identisch sind.

% palindrom/1
% palindrom(Liste)
palindrom(PL):-               
     palindrom(PL,[]).        

% palindrom/2
% palindrom(Liste, Akkumulator)
palindrom(T,T).               % Ankerklausel 1
palindrom([_|T],T).           % Ankerklausel 2
palindrom([H|T],Acc):-
     palindrom(T,[H|Acc]).    % rekursiver Aufruf des Prädikates palindrom/2


%%% Lösung Nr 2:
%
%% Korollar:
% Die zweite Lösungsstrategie basiert auf dem Prädikat reverse/2, 
% welches auf Seite 13 von Foliensatz 6 bereits implementiert wurde.
% reverse/2 prüft, ob eine Liste gleich der anderen ist, wenn man die Reihenfolge der Elemente umdreht.

% reverse/2
% reverse(Liste,UmgekehrteListe)
reverse(L,RL):- reverse(L,[],RL).

% reverse/3
% reverse(Liste,Akkumulator,UmgekehrteListe)
reverse([],RL,RL).
reverse([H|T],RT,RL):-
     reverse(T,[H|RT],RL).
     
%%% Lösung:
% Die Liste PL ist ein Palindrom, 
% wenn die Elemente der Liste in umgekehrter Reihenfolge dieselbe Liste ergeben.

% palindrom_rev/1 , alternative Definition mit reverse/2:
palindrom_rev(PL) :- reverse(PL,PL).


%% Testen (optional)
% Diese Tests kannst du manuell in deinem Prolog Interpreter durchführen.

% ?- palindrom([a,b,c,b,a]).
% -> true.

% ?- palindrom_rev([d,e,f,e,d]).
% -> true.
