%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                   %
% Übung: sublist/2                                                  %
% Überlege dir eine alternative Definition für sublist/2            %
%                                                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%
%% Erläuterung:
% Das Prädikat sublist/2 soll erkennen, ob Liste A eine Subliste der Liste B ist. 
% Liste A ist eine Subliste der Liste B, wenn alle Elemente aus Liste A in gleicher Reihenfolge auch in Liste B auftreten.
% Sonderfall: Die leere Liste ist eine Subliste der leeren Liste.

% auf Seite 9 von Foliensatz 6 der Prolog Vorlesung haben wir bereits eine Version von sublist/2 implementiert.
% Diese Lösung basierte auf der Verwendung von prefix/2 und suffix/2:
sublist(SL,L):- suffix(P,L), prefix(SL,P).

%
%% Korrolar:
% Unsere alternative Definition von sublist/2 basiert auf dem Prädikat my_append/3.
% my_append(A,B,C) fügt Liste A und Liste B zusammen, wodurch Liste C entsteht. 

% my_append/3
% my_append(Liste1,Liste2,ZusammengefügteListe)
my_append([],L,L).
my_append([H|T1],L2,[H|T3]):-
    my_append(T1,L2,T3).
    
    
%%% Lösung:
% Unsere Lösung sublist2(SL,L) beruht auf folgendem Gedankengang:
% Wenn man eine Liste mit einer weiteren Liste, welche wir L2 nennen, zusammenfügen kann und Liste L erhält,
% und wenn unsere Sublist SL zusammengefügt mit einer weiteren Liste die Liste L2 ergibt,
% dann ist SL ist eine Subliste von L.


% sublist/2
% sublist(Subliste,Liste)
sublist2(SL,L):-            % Liste SL ist Subliste von Liste L, 
    my_append(_,L2,L),      % wenn man eine Liste und eine zweite Liste L2 zusammenfügt und dadurch Liste L erhält
    my_append(SL,_,L2).     % und wenn das Zusammenfügen der Liste SL mit einer weiteren Liste die Liste L2 ergibt
    
    
%
%% Testen (optional)
% Diese Tests kannst du manuell in deinem Prolog Interpreter durchführen.

% ?- sublist2([a],[a,b,c]).
% -> true.

% ?- sublist2([a,b,c],[d,e,a,b,c,f,g]).
% -> true.

% ?- sublist2([d,e],[a,b,c,d,e]).
% -> true.
