%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                               %
% Übung swapfl/2                                                %
% Schreibe ein Prädikat swapfl/2 , das zwei Listen akzeptiert,  %
% wenn die eine aus der anderen durch Vertauschen des ersten    %
% und des letzten Elements hervorgeht                           %
%                                                               %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%
%% Erläuterung:
% Bei dem Prädikat werden zwei Listen betrachtet. Das erste Element der ersten Liste soll dabei das letzte Element der zweiten Liste sein. 
% Umgekehrt soll auch gelten, dass das erste Element der zweiten Liste, das letzte Element der ersten Liste sein soll. 
% Der mittlere Teil der Liste soll dabei gleich sein.

% Als Beispiel ist gegeben:
?- swapfl([a,b,c,d],[d,b,c,a]).   % a und d sind vertauscht
true.

%%% 1. Lösungsansatz mit my_append/3
% Bei diesem Prädikat interessieren wir uns besonders für das jeweils erste und letzte Element der beiden Listen. An das erste Element einer Liste kommt man bekanntlich,
% indem man den Head der Liste betrachtet. Mithilfe von append kann man auch sicherstellen, welches Element an der letzten Stelle einer Liste stehen soll:
% Die Konkatenation einer Liste mit einem einzigen Element ergibt eine Liste deren letztes Element wir genau kennen. 
% Nun muss man sich überlegen welche Bausteine man hat, und wie diese zusammenzusetzen sind.
%
%   Abstrakt (also Achtung, keine richtige Prolognotation) kann man sich das so vorstellen:  
%       [Head1 | MittlereListe1 | LetztesElement1]
%       [Head2 | MittlereListe2 | LetztesElement2]
%
%   Da der mittlere Teil gleich soll, benennen wir diese gleich.
%       [Head1 | MittlereListe | LetztesElement1]
%       [Head2 | MittlereListe | LetztesElement2]
%
%   Nun wissen wir ja auch, dass der Head der ersten Liste, also hier Head1 das letzte Element der zweiten Liste sein sollte und 
%   umgekehrt Head2 das letzte Element der ersten Liste. 
%   Das würde zu folgender Darstellung führen:
%       [Head1 | MittlereListe | Head2]
%       [Head2 | MittlereListe | Head1]
%
% Jetzt sind wir an der Stelle an der wir die Elemente mit my_append/3 nur noch richtig zusammenstellen müssen, 
% indem man sich fragt, was muss mit append wie zusammgensetzt werden und was ist das Ergebnis?

% my_append/3
my_append([],L,L).
my_append([H|T1],L2,[H|T3]):- my_append(T1,L2,T3).

swapfl([Head1|T1], [Head2|T2]):-             % Man trennt von beiden Listen den Kopf ab, die Tails dürfen dabei nicht automatisch gleich sein
     my_append(MittlereListe,[Head1],T2),    % wenn man an eine Liste (hier MittlereListe) den Head der ersten Liste anfügt, bekommt man den Tail der zweiten Liste
     my_append(MittlereListe,[Head2],T1).    % wenn man an dieselbe Liste wie oben (wieder MittlereListe) den Head der zweiten Liste anfügt, bekommt man den Tail der ersten Liste


%%% 2. Lösungsansatz mit reverse/3
% Wie auch beim ersten Lösungsansatz kann man sich bei der Lösung mti reverse die Liste folgendermaßen vorstellen
%       [Head1 | MittlereListe | Head2]
%       [Head2 | MittlereListe | Head1]
% Was hier vielleicht auffällt ist, dass so wie die Listen hier dargestellt werden, man eine nur Umdrehen muss und schon würden sie gleich aussehen. 

swapfl_rev([First|L1], [Last|L2]):-
     reverse(L1,[Last|L1Rev]),
     reverse([First|L1Rev],L2).
