%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                                       %
%% Übung: wiederhol/1                                                                   %
% Schreibe ein Prädikat wiederhol/1, das Wiederholwörter erkennt.                       %
% Ein Wort ist ein Wiederholwort, wenn es aus genau zwei gleichen Teilen besteht.       %          
%                                                                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%
%% Erläuterung:
% Das Prädikat wiederhol/1 nimmt eine Liste als Argument und gibt "true" zurück,
% wenn sich die Liste in zwei identische Teile aufspalten lässt.
% Auch die leere Liste wird als Wiederholwort gewertet.


%
%% Korollar:
% Unsere Definition von wiederhol/1 basiert auf dem Prädikat my_append/3.
% my_append(A,B,C) fügt Liste A und Liste B zusammen, wodurch Liste C entsteht. 

% my_append/3
% my_append(Liste1,Liste2,ZusammengefügteListe)
my_append([],L,L).
my_append([H|T1],L2,[H|T3]):-
    my_append(T1,L2,T3).
    
    
%
%%% Lösung:
% Mit Hilfe von my_append/3 können wir testen, ob eine Liste sich in zwei identische Teile spalten lässt:
% Liste WL ist ein Wiederholwort bzw. eine Wiederhol-Liste,
% wenn durch Zusammenfügen der identischen Listen L und L die Liste WL entsteht.

%wiederhol/1
%wiederhol(WiederholListe)
wiederhol(WL) :-                            % Die Liste WL ist eine Wiederholungsliste, wenn
     my_append(L,L,WL).                     % durch das Zusammenfügen von L und L die Liste WL entsteht.


%
%% Testen (optional)
% Diese Tests kannst du manuell in deinem Prolog Interpreter durchführen.

% ?- wiederhol([a,b,c,a,b,c]).
% -> true.
